/[gentoo-x86]/eclass/linux-mod.eclass
Gentoo

Diff of /eclass/linux-mod.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.54 Revision 1.81
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2004 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-mod.eclass,v 1.54 2005/10/22 17:35:39 johnm Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-mod.eclass,v 1.81 2008/04/03 16:11:24 cardoe Exp $
4 4
5# Description: This eclass is used to interface with linux-info in such a way 5# Description: This eclass is used to interface with linux-info in such a way
6# to provide the functionality required and initial functions 6# to provide the functionality required and initial functions
7# required to install external modules against a kernel source 7# required to install external modules against a kernel source
8# tree. 8# tree.
9# 9#
10# Maintainer: John Mylchreest <johnm@gentoo.org> 10# Author(s): John Mylchreest <johnm@gentoo.org>,
11# Copyright 2004 Gentoo Linux 11# Stefan Schweizer <genstef@gentoo.org>
12# Maintainer: kernel-misc@gentoo.org
12# 13#
13# Please direct your bugs to the current eclass maintainer :) 14# Please direct your bugs to the current eclass maintainer :)
14 15
15# A Couple of env vars are available to effect usage of this eclass 16# A Couple of env vars are available to effect usage of this eclass
16# These are as follows: 17# These are as follows:
54# 55#
55# if the srcdir isnt specified, it assumes ${S} 56# if the srcdir isnt specified, it assumes ${S}
56# if the libdir isnt specified, it assumes misc. 57# if the libdir isnt specified, it assumes misc.
57# if the objdir isnt specified, it assumes srcdir 58# if the objdir isnt specified, it assumes srcdir
58 59
59# There is also support for automatyed modules.d file generation. 60# There is also support for automated modprobe.d/modules.d(2.4) file generation.
60# This can be explicitly enabled by setting any of the following variables. 61# This can be explicitly enabled by setting any of the following variables.
61# 62#
62# 63#
63# MODULESD_${modulename}_ENABLED This enables the modules.d file 64# MODULESD_${modulename}_ENABLED This enables the modules.d file
64# generation even if we dont 65# generation even if we dont
76# Each entry is a new line. 77# Each entry is a new line.
77# MODULES_${modulename}_DOCS This is a string list which contains 78# MODULES_${modulename}_DOCS This is a string list which contains
78# the full path to any associated 79# the full path to any associated
79# documents for $modulename 80# documents for $modulename
80 81
82# The order of these is important as both of linux-info and eutils contain
83# set_arch_to_kernel and set_arch_to_portage functions and the ones in eutils
84# are deprecated in favor of the ones in linux-info.
85# See http://bugs.gentoo.org/show_bug.cgi?id=127506
81 86
82inherit linux-info 87inherit eutils linux-info multilib
83EXPORT_FUNCTIONS pkg_setup pkg_postinst src_install src_compile pkg_postrm 88EXPORT_FUNCTIONS pkg_setup pkg_preinst pkg_postinst src_install src_compile pkg_postrm
84 89
85IUSE="" # don't put pcmcia here, rather in the ebuilds that actually support pcmcia 90IUSE="kernel_linux"
86SLOT="0" 91SLOT="0"
87DESCRIPTION="Based on the $ECLASS eclass" 92DESCRIPTION="Based on the $ECLASS eclass"
88RDEPEND="virtual/modutils 93RDEPEND="kernel_linux? ( virtual/modutils )"
89 pcmcia? ( virtual/pcmcia )" 94DEPEND="${RDEPEND}
90DEPEND="virtual/linux-sources
91 sys-apps/sed 95 sys-apps/sed"
92 pcmcia? ( virtual/pcmcia )"
93 96
94# eclass utilities 97# eclass utilities
95# ---------------------------------- 98# ----------------------------------
96 99
97check_vermagic() { 100check_vermagic() {
101 debug-print-function ${FUNCNAME} $*
102
98 local curr_gcc_ver=$(gcc -dumpversion) 103 local curr_gcc_ver=$(gcc -dumpversion)
99 local tmpfile old_chost old_gcc_ver result=0 104 local tmpfile old_chost old_gcc_ver result=0
100 105
101 tmpfile=`find ${KV_DIR}/ -iname "*.o.cmd" -exec grep usr/lib/gcc {} \; -quit` 106 tmpfile=`find ${KV_DIR}/ -iname "*.o.cmd" -exec grep usr/lib/gcc {} \; -quit`
102 tmpfile=${tmpfile//*usr/lib} 107 tmpfile=${tmpfile//*usr/lib}
129 ewarn "to match the kernel, or recompile the kernel first." 134 ewarn "to match the kernel, or recompile the kernel first."
130 die "GCC Version Mismatch." 135 die "GCC Version Mismatch."
131 fi 136 fi
132} 137}
133 138
134unpack_pcmcia_sources() {
135 # So while the two eclasses exist side-by-side and also the ebuilds inherit
136 # both we need to check for PCMCIA_SOURCE_DIR, and if we find it, then we
137 # bail out and assume pcmcia.eclass is working on it.
138 [[ -n ${PCMCIA_SOURCE_DIR} ]] && return 1
139
140 if [[ -f "${1}" ]]; then
141 PCMCIA_SOURCE_DIR="${WORKDIR}/pcmcia-cs/"
142
143 ebegin "Decompressing pcmcia-cs sources"
144 mkdir -p ${PCMCIA_SOURCE_DIR}
145 tar -xjf ${1} -C ${PCMCIA_SOURCE_DIR}
146 eend $?
147
148 if [[ -f ${PCMCIA_SOURCE_DIR}/pcmcia-cs-version ]]; then
149 PCMCIA_VERSION=$(cat ${PCMCIA_SOURCE_DIR}/pcmcia-cs-version)
150 einfo "Found pcmcia-cs-${PCMCIA_VERSION}"
151 fi
152 fi
153}
154
155# Dummy function for compatibility.
156pcmcia_configure() { return 0; }
157
158pcmcia_src_unpack() {
159 local pcmcia_tbz="${ROOT}/usr/src/pcmcia-cs/pcmcia-cs-build-env.tbz2"
160
161 # if the kernel has pcmcia support built in, then we just ignore all this.
162 if linux_chkconfig_present PCMCIA; then
163 einfo "Kernel based PCMCIA support has been detected."
164 else
165 if kernel_is 2 4; then
166 unpack_pcmcia_sources ${pcmcia_tbz};
167 else
168 einfo "We have detected that you are running a 2.6 kernel"
169 einfo "but you are not using the built-in PCMCIA support."
170 einfo "We will assume you know what you are doing, but please"
171 einfo "consider using the built in PCMCIA support instead."
172 sleep 10
173
174 unpack_pcmcia_sources ${pcmcia_tbz};
175 fi
176 fi
177}
178
179use_m() { 139use_m() {
140 debug-print-function ${FUNCNAME} $*
141
180 # if we haven't determined the version yet, we need too. 142 # if we haven't determined the version yet, we need too.
181 get_version; 143 get_version;
182 144
183 # if the kernel version is greater than 2.6.6 then we should use 145 # if the kernel version is greater than 2.6.6 then we should use
184 # M= instead of SUBDIRS= 146 # M= instead of SUBDIRS=
185 [ ${KV_MAJOR} -eq 2 -a ${KV_MINOR} -gt 5 -a ${KV_PATCH} -gt 5 ] && \ 147 [ ${KV_MAJOR} -eq 2 -a ${KV_MINOR} -gt 5 -a ${KV_PATCH} -gt 5 ] && \
186 return 0 || return 1 148 return 0 || return 1
187} 149}
188 150
189convert_to_m() { 151convert_to_m() {
152 debug-print-function ${FUNCNAME} $*
153
190 if use_m 154 if use_m
191 then 155 then
192 [ ! -f "${1}" ] && \ 156 [ ! -f "${1}" ] && \
193 die "convert_to_m() requires a filename as an argument" 157 die "convert_to_m() requires a filename as an argument"
194 ebegin "Converting ${1/${WORKDIR}\//} to use M= instead of SUBDIRS=" 158 ebegin "Converting ${1/${WORKDIR}\//} to use M= instead of SUBDIRS="
196 eend $? 160 eend $?
197 fi 161 fi
198} 162}
199 163
200update_depmod() { 164update_depmod() {
165 debug-print-function ${FUNCNAME} $*
166
201 # if we haven't determined the version yet, we need too. 167 # if we haven't determined the version yet, we need too.
202 get_version; 168 get_version;
203 169
204 ebegin "Updating module dependencies for ${KV_FULL}" 170 ebegin "Updating module dependencies for ${KV_FULL}"
205 if [ -r ${KV_OUT_DIR}/System.map ] 171 if [ -r ${KV_OUT_DIR}/System.map ]
214 ewarn 180 ewarn
215 fi 181 fi
216} 182}
217 183
218update_modules() { 184update_modules() {
185 debug-print-function ${FUNCNAME} $*
186
219 if [ -x /sbin/modules-update ] && \ 187 if [ -x /sbin/update-modules ] && \
220 grep -v -e "^#" -e "^$" ${D}/etc/modules.d/* >/dev/null 2>&1; then 188 grep -v -e "^#" -e "^$" ${D}/etc/modules.d/* >/dev/null 2>&1; then
221 ebegin "Updating modules.conf" 189 ebegin "Updating modules.conf"
222 /sbin/modules-update 190 /sbin/update-modules
223 eend $? 191 eend $?
192 elif [ -x /sbin/update-modules ] && \
193 grep -v -e "^#" -e "^$" ${D}/etc/modules.d/* >/dev/null 2>&1; then
194 ebegin "Updating modules.conf"
195 /sbin/update-modules
196 eend $?
224 fi 197 fi
225} 198}
226 199
227move_old_moduledb() { 200move_old_moduledb() {
201 debug-print-function ${FUNCNAME} $*
202
228 local OLDDIR=${ROOT}/usr/share/module-rebuild/ 203 local OLDDIR=${ROOT}/usr/share/module-rebuild/
229 local NEWDIR=${ROOT}/var/lib/module-rebuild/ 204 local NEWDIR=${ROOT}/var/lib/module-rebuild/
230 205
231 if [[ -f ${OLDDIR}/moduledb ]]; then 206 if [[ -f ${OLDDIR}/moduledb ]]; then
232 [[ ! -d ${NEWDIR} ]] && mkdir -p ${NEWDIR} 207 [[ ! -d ${NEWDIR} ]] && mkdir -p ${NEWDIR}
236 rmdir ${OLDDIR} 211 rmdir ${OLDDIR}
237 fi 212 fi
238} 213}
239 214
240update_moduledb() { 215update_moduledb() {
216 debug-print-function ${FUNCNAME} $*
217
241 local MODULEDB_DIR=${ROOT}/var/lib/module-rebuild/ 218 local MODULEDB_DIR=${ROOT}/var/lib/module-rebuild/
242 move_old_moduledb 219 move_old_moduledb
243 220
244 if [[ ! -f ${MODULEDB_DIR}/moduledb ]]; then 221 if [[ ! -f ${MODULEDB_DIR}/moduledb ]]; then
245 [[ ! -d ${MODULEDB_DIR} ]] && mkdir -p ${MODULEDB_DIR} 222 [[ ! -d ${MODULEDB_DIR} ]] && mkdir -p ${MODULEDB_DIR}
246 touch ${MODULEDB_DIR}/moduledb 223 touch ${MODULEDB_DIR}/moduledb
247 fi 224 fi
225
248 if [[ -z $(grep ${CATEGORY}/${PN}-${PVR} ${MODULEDB_DIR}/moduledb) ]]; then 226 if ! grep -qs ${CATEGORY}/${PN}-${PVR} ${MODULEDB_DIR}/moduledb ; then
249 einfo "Adding module to moduledb." 227 einfo "Adding module to moduledb."
250 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${MODULEDB_DIR}/moduledb 228 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${MODULEDB_DIR}/moduledb
251 fi 229 fi
252} 230}
253 231
254remove_moduledb() { 232remove_moduledb() {
233 debug-print-function ${FUNCNAME} $*
234
255 local MODULEDB_DIR=${ROOT}/var/lib/module-rebuild/ 235 local MODULEDB_DIR=${ROOT}/var/lib/module-rebuild/
256 move_old_moduledb 236 move_old_moduledb
257 237
258 if [[ -n $(grep ${CATEGORY}/${PN}-${PVR} ${MODULEDB_DIR}/moduledb) ]]; then 238 if grep -qs ${CATEGORY}/${PN}-${PVR} ${MODULEDB_DIR}/moduledb ; then
259 einfo "Removing ${CATEGORY}/${PN}-${PVR} from moduledb." 239 einfo "Removing ${CATEGORY}/${PN}-${PVR} from moduledb."
260 sed -ie "/.*${CATEGORY}\/${P}.*/d" ${MODULEDB_DIR}/moduledb 240 sed -i -e "/.*${CATEGORY}\/${PN}-${PVR}.*/d" ${MODULEDB_DIR}/moduledb
261 fi 241 fi
262} 242}
263 243
264set_kvobj() { 244set_kvobj() {
245 debug-print-function ${FUNCNAME} $*
246
265 if kernel_is 2 6 247 if kernel_is 2 6
266 then 248 then
267 KV_OBJ="ko" 249 KV_OBJ="ko"
268 else 250 else
269 KV_OBJ="o" 251 KV_OBJ="o"
271 # Do we really need to know this? 253 # Do we really need to know this?
272 # Lets silence it. 254 # Lets silence it.
273 # einfo "Using KV_OBJ=${KV_OBJ}" 255 # einfo "Using KV_OBJ=${KV_OBJ}"
274} 256}
275 257
258get-KERNEL_CC() {
259 debug-print-function ${FUNCNAME} $*
260
261 local kernel_cc
262 if [ -n "${KERNEL_ABI}" ]; then
263 # In future, an arch might want to define CC_$ABI
264 #kernel_cc="$(get_abi_CC)"
265 #[ -z "${kernel_cc}" ] &&
266 kernel_cc="$(tc-getCC $(ABI=${KERNEL_ABI} get_abi_CHOST))"
267 else
268 kernel_cc=$(tc-getCC)
269 fi
270 echo "${kernel_cc}"
271}
272
276generate_modulesd() { 273generate_modulesd() {
274 debug-print-function ${FUNCNAME} $*
275
277 # This function will generate the neccessary modules.d file from the 276 # This function will generate the neccessary modules.d file from the
278 # information contained in the modules exported parms 277 # information contained in the modules exported parms
279 278
280 local currm_path currm currm_t t myIFS myVAR 279 local currm_path currm currm_t t myIFS myVAR
281 local module_docs module_enabled module_aliases \ 280 local module_docs module_enabled module_aliases \
403 fi 402 fi
404 403
405 #----------------------------------------------------------------------- 404 #-----------------------------------------------------------------------
406 405
407 # then we install it 406 # then we install it
407 if kernel_is ge 2 6; then
408 insinto /etc/modprobe.d
409 else
408 insinto /etc/modules.d 410 insinto /etc/modules.d
411 fi
409 newins ${module_config} ${currm_path//*\/} 412 newins ${module_config} ${currm_path//*\/}
410 413
411 # and install any documentation we might have. 414 # and install any documentation we might have.
412 [[ -n ${module_docs} ]] && dodoc ${module_docs} 415 [[ -n ${module_docs} ]] && dodoc ${module_docs}
413 done 416 done
414 eend 0 417 eend 0
415 return 0 418 return 0
416} 419}
417 420
418find_module_params() { 421find_module_params() {
422 debug-print-function ${FUNCNAME} $*
423
419 local matched_offset=0 matched_opts=0 test="${@}" temp_var result 424 local matched_offset=0 matched_opts=0 test="${@}" temp_var result
420 local i=0 y=0 z=0 425 local i=0 y=0 z=0
421 426
422 for((i=0; i<=${#test}; i++)) 427 for((i=0; i<=${#test}; i++))
423 do 428 do
457 462
458# default ebuild functions 463# default ebuild functions
459# -------------------------------- 464# --------------------------------
460 465
461linux-mod_pkg_setup() { 466linux-mod_pkg_setup() {
467 debug-print-function ${FUNCNAME} $*
468
462 linux-info_pkg_setup; 469 linux-info_pkg_setup;
470 require_configured_kernel
463 check_kernel_built; 471 check_kernel_built;
464 check_modules_supported; 472 strip_modulenames;
473 [[ -n ${MODULE_NAMES} ]] && check_modules_supported
465 set_kvobj; 474 set_kvobj;
475 # Commented out with permission from johnm until a fixed version for arches
476 # who intentionally use different kernel and userland compilers can be
477 # introduced - Jason Wever <weeve@gentoo.org>, 23 Oct 2005
466 check_vermagic; 478 #check_vermagic;
467} 479}
468 480
469linux-mod_src_compile() { 481strip_modulenames() {
470 local modulename libdir srcdir objdir i n myARCH="${ARCH}" 482 debug-print-function ${FUNCNAME} $*
471 ARCH="$(tc-arch-kernel)"
472 483
473 BUILD_TARGETS=${BUILD_TARGETS:-clean module} 484 local i
474
475 for i in ${MODULE_IGNORE} 485 for i in ${MODULE_IGNORE}; do
476 do
477 MODULE_NAMES=${MODULE_NAMES//${i}(*} 486 MODULE_NAMES=${MODULE_NAMES//${i}(*}
478 done 487 done
488}
479 489
490linux-mod_src_compile() {
491 debug-print-function ${FUNCNAME} $*
492
493 local modulename libdir srcdir objdir i n myARCH="${ARCH}" myABI="${ABI}"
494 ARCH="$(tc-arch-kernel)"
495 ABI="${KERNEL_ABI}"
496
497 BUILD_TARGETS=${BUILD_TARGETS:-clean module}
498 strip_modulenames;
499 cd "${S}"
480 for i in ${MODULE_NAMES} 500 for i in ${MODULE_NAMES}
481 do 501 do
482 unset libdir srcdir objdir 502 unset libdir srcdir objdir
483 for n in $(find_module_params ${i}) 503 for n in $(find_module_params ${i})
484 do 504 do
495 if [[ -n ${ECONF_PARAMS} ]] 515 if [[ -n ${ECONF_PARAMS} ]]
496 then 516 then
497 econf ${ECONF_PARAMS} || \ 517 econf ${ECONF_PARAMS} || \
498 die "Unable to run econf ${ECONF_PARAMS}" 518 die "Unable to run econf ${ECONF_PARAMS}"
499 fi 519 fi
500 520
501 emake ${BUILD_FIXES} ${BUILD_PARAMS} ${BUILD_TARGETS} \ 521 # This looks messy, but it is needed to handle multiple variables
502 || die "Unable to make \ 522 # being passed in the BUILD_* stuff where the variables also have
503 ${BUILD_FIXES} ${BUILD_PARAMS} ${BUILD_TARGETS}." 523 # spaces that must be preserved. If don't do this, then the stuff
524 # inside the variables gets used as targets for Make, which then
525 # fails.
526 eval "emake HOSTCC=\"$(tc-getBUILD_CC)\" \
527 CC=\"$(get-KERNEL_CC)\" \
528 LDFLAGS=\"$(get_abi_LDFLAGS)\" \
529 ${BUILD_FIXES} \
530 ${BUILD_PARAMS} \
531 ${BUILD_TARGETS} " \
532 || die "Unable to emake HOSTCC="$(tc-getBUILD_CC)" CC="$(get-KERNEL_CC)" LDFLAGS="$(get_abi_LDFLAGS)" ${BUILD_FIXES} ${BUILD_PARAMS} ${BUILD_TARGETS}"
504 touch ${srcdir}/.built 533 touch ${srcdir}/.built
505 cd ${OLDPWD} 534 cd ${OLDPWD}
506 fi 535 fi
507 done 536 done
508 537
509 ARCH="${myARCH}" 538 ARCH="${myARCH}"
539 ABI="${myABI}"
510} 540}
511 541
512linux-mod_src_install() { 542linux-mod_src_install() {
543 debug-print-function ${FUNCNAME} $*
544
513 local modulename libdir srcdir objdir i n 545 local modulename libdir srcdir objdir i n
514 546
515 for i in ${MODULE_IGNORE} 547 strip_modulenames;
516 do
517 MODULE_NAMES=${MODULE_NAMES//${i}(*}
518 done
519
520 for i in ${MODULE_NAMES} 548 for i in ${MODULE_NAMES}
521 do 549 do
522 unset libdir srcdir objdir 550 unset libdir srcdir objdir
523 for n in $(find_module_params ${i}) 551 for n in $(find_module_params ${i})
524 do 552 do
527 libdir=${libdir:-misc} 555 libdir=${libdir:-misc}
528 srcdir=${srcdir:-${S}} 556 srcdir=${srcdir:-${S}}
529 objdir=${objdir:-${srcdir}} 557 objdir=${objdir:-${srcdir}}
530 558
531 einfo "Installing ${modulename} module" 559 einfo "Installing ${modulename} module"
532 cd ${objdir} 560 cd ${objdir} || die "${objdir} does not exist"
533 insinto ${ROOT}lib/modules/${KV_FULL}/${libdir} 561 insinto /lib/modules/${KV_FULL}/${libdir}
534 doins ${modulename}.${KV_OBJ} 562 doins ${modulename}.${KV_OBJ} || die "doins ${modulename}.${KV_OBJ} failed"
535 cd ${OLDPWD} 563 cd ${OLDPWD}
536 564
537 generate_modulesd ${objdir}/${modulename} 565 generate_modulesd ${objdir}/${modulename}
538 done 566 done
539} 567}
540 568
569linux-mod_pkg_preinst() {
570 debug-print-function ${FUNCNAME} $*
571
572 [ -d "${D}lib/modules" ] && UPDATE_DEPMOD=true || UPDATE_DEPMOD=false
573 [ -d "${D}etc/modules.d" ] && UPDATE_MODULES=true || UPDATE_MODULES=false
574 [ -d "${D}lib/modules" ] && UPDATE_MODULEDB=true || UPDATE_MODULEDB=false
575}
576
541linux-mod_pkg_postinst() { 577linux-mod_pkg_postinst() {
542 update_depmod; 578 debug-print-function ${FUNCNAME} $*
543 update_modules; 579
544 update_moduledb; 580 ${UPDATE_DEPMOD} && update_depmod;
581 ${UPDATE_MODULES} && update_modules;
582 ${UPDATE_MODULEDB} && update_moduledb;
545} 583}
546 584
547linux-mod_pkg_postrm() { 585linux-mod_pkg_postrm() {
586 debug-print-function ${FUNCNAME} $*
548 remove_moduledb; 587 remove_moduledb;
549} 588}

Legend:
Removed from v.1.54  
changed lines
  Added in v.1.81

  ViewVC Help
Powered by ViewVC 1.1.20